"use strict";function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t?t:i}Object.defineProperty(exports,"__esModule",{value:!0});var classCallCheck=function(t,i){if(!(t instanceof i))throw new TypeError("Cannot call a class as a function")},createClass=function(){function t(t,i){for(var e=0;e<i.length;e++){var n=i[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(i,e,n){return e&&t(i.prototype,e),n&&t(i,n),i}}(),_extends=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n])}return t},Spring=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};classCallCheck(this,t),this._listeners=[],this._currentAnimationStep=0,this._currentTime=0,this._springTime=0,this._currentValue=0,this._currentVelocity=0,this._isAnimating=!1,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(i.fromValue,0),toValue:withDefault(i.toValue,0),stiffness:withDefault(i.stiffness,100),damping:withDefault(i.damping,10),mass:withDefault(i.mass,1),initialVelocity:withDefault(i.initialVelocity,0),overshootClamping:withDefault(i.overshootClamping,!1),allowsOverdamping:withDefault(i.allowsOverdamping,!1),restVelocityThreshold:withDefault(i.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(i.restDisplacementThreshold,.001)}}return createClass(t,[{key:"start",value:function(){var t=this,i=this._config,e=i.fromValue,n=i.toValue,s=i.initialVelocity;e===n&&0===s||(this._reset(),this._isAnimating=!0,this._currentAnimationStep||(this._notifyListeners("onStart"),this._currentAnimationStep=requestAnimationFrame(function(i){t._step(i)})))}},{key:"stop",value:function(){this._isAnimating&&(this._isAnimating=!1,this._notifyListeners("onStop"),this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=0))}},{key:"updateConfig",value:function(t){this._advanceSpringToTime(performance.now());var i={fromValue:this._currentValue,initialVelocity:this._currentVelocity};this._config=_extends({},this._config,i,t),this._reset()}},{key:"onStart",value:function(t){return this._listeners.push({onStart:t}),this}},{key:"onUpdate",value:function(t){return this._listeners.push({onUpdate:t}),this}},{key:"onStop",value:function(t){return this._listeners.push({onStop:t}),this}},{key:"removeListener",value:function(t){return this._listeners=this._listeners.reduce(function(i,e){return-1!==Object.values(e).indexOf(t)||i.push(e),i},[]),this}},{key:"removeAllListeners",value:function(){return this._listeners=[],this}},{key:"_reset",value:function(){this._currentTime=0,this._springTime=0,this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity}},{key:"_notifyListeners",value:function(t){var i=this;this._listeners.forEach(function(e){var n=e[t];"function"==typeof n&&n(i)})}},{key:"_step",value:function(t){var i=this;this._advanceSpringToTime(t,!0),this._isAnimating&&(this._currentAnimationStep=requestAnimationFrame(function(t){return i._step(t)}))}},{key:"_advanceSpringToTime",value:function(i){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(this._isAnimating){0===this._currentTime&&(this._currentTime=i);var n=i-this._currentTime;n>t.MAX_DELTA_TIME_MS&&(n=t.MAX_DELTA_TIME_MS),this._springTime+=n;var s=this._config.damping,r=this._config.mass,a=this._config.stiffness,o=this._config.fromValue,h=this._config.toValue,u=-this._config.initialVelocity;invariant(r>0,"Mass value must be greater than 0"),invariant(a>0,"Stiffness value must be greater than 0"),invariant(s>0,"Damping value must be greater than 0");var l=s/(2*Math.sqrt(a*r)),c=Math.sqrt(a/r)/1e3,f=c*Math.sqrt(1-l*l),_=c*Math.sqrt(l*l-1),p=h-o;l>1&&!this._config.allowsOverdamping&&(l=1);var g=0,m=0,v=this._springTime;if(l<1){var y=Math.exp(-l*c*v);g=h-y*((u+l*c*p)/f*Math.sin(f*v)+p*Math.cos(f*v)),m=l*c*y*(Math.sin(f*v)*(u+l*c*p)/f+p*Math.cos(f*v))-y*(Math.cos(f*v)*(u+l*c*p)-f*p*Math.sin(f*v))}else if(1===l){var V=Math.exp(-c*v);g=h-V*(p+(u+c*p)*v),m=V*(u*(v*c-1)+v*p*(c*c))}else{var d=Math.exp(-l*c*v);g=h-d*((u+l*c*p)*Math.sinh(_*v)+_*p*Math.cosh(_*v))/_,m=d*l*c*(Math.sinh(_*v)*(u+l*c*p)+p*_*Math.cosh(_*v))/_-d*(_*Math.cosh(_*v)*(u+l*c*p)+_*_*p*Math.sinh(_*v))/_}if(this._currentTime=i,this._currentValue=g,this._currentVelocity=m,e&&(this._notifyListeners("onUpdate"),this._isAnimating))return this._isSpringOvershooting()||this._isSpringAtRest()?(0!==a&&(this._currentValue=h,this._currentVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}}},{key:"_isSpringOvershooting",value:function(){var t=this._config,i=t.stiffness,e=t.fromValue,n=t.toValue,s=!1;return t.overshootClamping&&0!==i&&(s=e<n?this._currentValue>n:this._currentValue<n),s}},{key:"_isSpringAtRest",value:function(){var t=this._config,i=t.stiffness,e=t.toValue,n=t.restDisplacementThreshold,s=t.restVelocityThreshold,r=Math.abs(this._currentVelocity)<=s;return 0!==i&&Math.abs(e-this._currentValue)<=n&&r}},{key:"currentValue",get:function(){return this._currentValue}},{key:"currentVelocity",get:function(){return this._currentVelocity}},{key:"isAtRest",get:function(){return this._isSpringAtRest()}},{key:"isAnimating",get:function(){return this._isAnimating}}]),t}();Spring.MAX_DELTA_TIME_MS=1/60*1e3*4,exports.Spring=Spring;
//# sourceMappingURL=wobble.cjs.js.map
