function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t?t:i}var _extends=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var s in e)Object.prototype.hasOwnProperty.call(e,s)&&(t[s]=e[s])}return t};class Spring{constructor(t={}){this._listeners=[],this._currentAnimationStep=0,this._currentTime=0,this._springTime=0,this._currentValue=0,this._currentVelocity=0,this._isAnimating=!1,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(t.fromValue,0),toValue:withDefault(t.toValue,0),stiffness:withDefault(t.stiffness,100),damping:withDefault(t.damping,10),mass:withDefault(t.mass,1),initialVelocity:withDefault(t.initialVelocity,0),overshootClamping:withDefault(t.overshootClamping,!1),allowsOverdamping:withDefault(t.allowsOverdamping,!1),restVelocityThreshold:withDefault(t.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(t.restDisplacementThreshold,.001)}}start(){const{fromValue:t,toValue:i,initialVelocity:e}=this._config;t===i&&0===e||(this._reset(),this._isAnimating=!0,this._currentAnimationStep||(this._notifyListeners("onStart"),this._currentAnimationStep=requestAnimationFrame(t=>{this._step(t)})))}stop(){this._isAnimating&&(this._isAnimating=!1,this._notifyListeners("onStop"),this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=0))}get currentValue(){return this._currentValue}get currentVelocity(){return this._currentVelocity}get isAtRest(){return this._isSpringAtRest()}get isAnimating(){return this._isAnimating}updateConfig(t){this._advanceSpringToTime(performance.now());const i={fromValue:this._currentValue,initialVelocity:this._currentVelocity};this._config=_extends({},this._config,i,t),this._reset()}onStart(t){return this._listeners.push({onStart:t}),this}onUpdate(t){return this._listeners.push({onUpdate:t}),this}onStop(t){return this._listeners.push({onStop:t}),this}removeListener(t){return this._listeners=this._listeners.reduce((i,e)=>(-1!==Object.values(e).indexOf(t)||i.push(e),i),[]),this}removeAllListeners(){return this._listeners=[],this}_reset(){this._currentTime=0,this._springTime=0,this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity}_notifyListeners(t){this._listeners.forEach(i=>{const e=i[t];"function"==typeof e&&e(this)})}_step(t){this._advanceSpringToTime(t,!0),this._isAnimating&&(this._currentAnimationStep=requestAnimationFrame(t=>this._step(t)))}_advanceSpringToTime(t,i=!1){if(!this._isAnimating)return;0===this._currentTime&&(this._currentTime=t);let e=t-this._currentTime;e>Spring.MAX_DELTA_TIME_MS&&(e=Spring.MAX_DELTA_TIME_MS),this._springTime+=e;const s=this._config.damping,n=this._config.mass,r=this._config.stiffness,a=this._config.fromValue,h=this._config.toValue,o=-this._config.initialVelocity;invariant(n>0,"Mass value must be greater than 0"),invariant(r>0,"Stiffness value must be greater than 0"),invariant(s>0,"Damping value must be greater than 0");let c=s/(2*Math.sqrt(r*n));const l=Math.sqrt(r/n)/1e3,u=l*Math.sqrt(1-c*c),_=l*Math.sqrt(c*c-1),f=h-a;c>1&&!this._config.allowsOverdamping&&(c=1);let m=0,g=0;const p=this._springTime;if(c<1){const t=Math.exp(-c*l*p);m=h-t*((o+c*l*f)/u*Math.sin(u*p)+f*Math.cos(u*p)),g=c*l*t*(Math.sin(u*p)*(o+c*l*f)/u+f*Math.cos(u*p))-t*(Math.cos(u*p)*(o+c*l*f)-u*f*Math.sin(u*p))}else if(1===c){const t=Math.exp(-l*p);m=h-t*(f+(o+l*f)*p),g=t*(o*(p*l-1)+p*f*(l*l))}else{const t=Math.exp(-c*l*p);m=h-t*((o+c*l*f)*Math.sinh(_*p)+_*f*Math.cosh(_*p))/_,g=t*c*l*(Math.sinh(_*p)*(o+c*l*f)+f*_*Math.cosh(_*p))/_-t*(_*Math.cosh(_*p)*(o+c*l*f)+_*_*f*Math.sinh(_*p))/_}return this._currentTime=t,this._currentValue=m,this._currentVelocity=g,i&&(this._notifyListeners("onUpdate"),this._isAnimating)&&(this._isSpringOvershooting()||this._isSpringAtRest())?(0!==r&&(this._currentValue=h,this._currentVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}_isSpringOvershooting(){const{stiffness:t,fromValue:i,toValue:e,overshootClamping:s}=this._config;let n=!1;return s&&0!==t&&(n=i<e?this._currentValue>e:this._currentValue<e),n}_isSpringAtRest(){const{stiffness:t,toValue:i,restDisplacementThreshold:e,restVelocityThreshold:s}=this._config,n=Math.abs(this._currentVelocity)<=s;return 0!==t&&Math.abs(i-this._currentValue)<=e&&n}}Spring.MAX_DELTA_TIME_MS=1/60*1e3*4;export{Spring};
//# sourceMappingURL=wobble.es.js.map
